package cn.iocoder.yudao.module.sale.vo.offer;

import cn.iocoder.yudao.module.customer.vo.customerFollowup.CustomerFollowupBackVO;
import cn.iocoder.yudao.module.depository.dto.LogisticsInfoDto;
import cn.iocoder.yudao.module.sale.dal.dataobject.offer.OfferProdDO;
import cn.iocoder.yudao.module.sale.vo.offer.prod.OfferProdRespVO;
import cn.iocoder.yudao.module.sale.vo.offer.transport.OfferTransportRespVO;
import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@ApiModel("管理后台 - 报价单管理 Response VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class OfferRespVO extends OfferBaseVO {

    @ApiModelProperty(value = "主键ID", required = true)
    private Long offerId;

    @ApiModelProperty(value = "创建时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @ApiModelProperty(value = "更新时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    @ApiModelProperty(value = "运输相关信息")
    private OfferTransportRespVO transportVO;

    @ApiModelProperty(value = "报价单商品列表")
    private List<OfferProdRespVO> offerProdRespVOList;

    @ApiModelProperty(value = "物流信息")
    private LogisticsInfoDto logisticsInfoDto;

    @ApiModelProperty(value = "始发地名称")
    private String departureName;

    @ApiModelProperty(value = "目的地名称")
    private String objectiveName;

    @ApiModelProperty(value = "业务员名称")
    private String creatorName;

    @ApiModelProperty(value = "更新业务员名称")
    private String updaterName;

    @ApiModelProperty(value = "跟进业务员")
    private String followUpSalesmanId;

    @ApiModelProperty(value = "跟进业务员名称")
    private String followUpSalesmanName;

    @ApiModelProperty(value = "关联客户名称")
    private String relationName;

    @ApiModelProperty(value = "联系人区号")
    private String relationAreaCode;

    @ApiModelProperty(value = "联系人手机号")
    private String relationPhone;


    // 线路相关
    @ApiModelProperty("始发仓库id")
    private Long startWarehouseId;
    @ApiModelProperty("始发仓库名称")
    private String startWarehouseName;
    @ApiModelProperty("目的仓库id")
    private Long destWarehouseId;
    @ApiModelProperty("目的仓库名称")
    private String destWarehouseName;
    @ExcelProperty("运输方式")
    private String transportType;


    @ApiModelProperty(value = "渠道名称")
    private String channelName;

    @ApiModelProperty(value = "渠道特性id")
    private String channelAttrId;

    @ApiModelProperty(value = "客户编号")
    private String customerNumber;

    @ApiModelProperty(value = "客户名称")
    private String customerName;

    @ApiModelProperty(value = "客户")
    private Long customerId;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "进入公海时间")
    private Date enterOpenSeaTime;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "预计进入公海时间")
    private Date estimateEnterOpenSeaTime;

    @ApiModelProperty(value = "客户经理所属部门")
    private String deptName;

    @ApiModelProperty(value = "业务员名称-客户经理")
    private String businessManagerName;

    @ApiModelProperty("最新跟进记录信息")
    @TableField(exist = false)
    private CustomerFollowupBackVO followupBackVO;

    @ApiModelProperty("商品明细")
    @TableField(exist = false)
    private List<OfferProdDO> offerProds;

    /**
     * 销售阶段 字典sale_stage
     */
    private Integer saleStage;

    /**
     * 销售阶段 字典ecw_offer_customer_status
     */
    private Integer customerStatus;

    /**
     * 销售阶段 字典ecw_offer_cargo_status
     */
    private Integer cargoStatus;

    /**
     * 销售阶段 字典ecw_offer_inquiry_source
     */
    private Integer inquirySource;

    /**
     * 厂家
     */
    private String manufacturer;

    /**
     * 厂家电话
     */
    private String manufacturerPhone;

    /**
     * 原因数据字典
     */
    private Integer reasonDict;

    /**
     * 预计发货时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date estimatedShippingTime;

    /**
     * 体积
     */
    private BigDecimal volume;
    /**
     * 重量
     */
    private BigDecimal weight;

    @ApiModelProperty(value = "是否特价")
    private Boolean specialPriceType;
}
